searchData={"items":[{"type":"module","title":"Webhoox","doc":"Package that makes it easy to deal with inbound webhooks.","ref":"Webhoox.html"},{"type":"module","title":"Installation - Webhoox","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `webhoox` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n[\n  {:webhoox, \"~> 0.1.3\"}\n]\nend\n```\n\n\nExample configuration for Mandrill with the Plug router\n```elixir\nforward(\"_incoming\",\n  to: Webhoox,\n  init_opts: [\n    adapter: Webhoox.Adapter.Mandrill,\n    adapter_opts: [\n      secret: \"i8PTcm8glMgsfaWf75bS1FQ\",\n      url: \"http://example.com\"\n    ],\n    handler: Example.Processor\n  ]\n)\n```\n\nExample configuration for Mandrill with the Phoenix router\n```elixir\nforward(\"_incoming\", Webhoox,\n  adapter: Webhoox.Adapter.Mandrill,\n  adapter_opts: [\n    secret: \"i8PTcm8glMgsfaWf75bS1FQ\",\n    url: \"http://example.com\"\n  ],\n  handler: Example.Processor\n)\n```\n\nExample configuration for Mailgun with the Plug router\n```elixir\nforward(\"_incoming\",\n  to: Webhoox,\n  init_opts: [\n    adapter: Webhoox.Adapter.Mailgun,\n    adapter_opts: [\n      api_key: \"some-key\"\n    ],\n    handler: Example.Processor\n  ]\n)\n```\n\nExample configuration for custom adapter\n```elixir\nforward(\"_incoming\", Webhoox,\n  adapter: Your.Custom.Adapter,\n  adapter_opts: [some_option: \"some-option\"],\n  handler: Your.Processor\n)\n```\n\nExample processor\n```elixir\ndefmodule Example.Processor do\n  @behaviour Webhoox.Handler\n\n  def process(%Webhoox.Webhook.Email{} = email) do\n    IO.inspect(email)\n  end\nend\n\n```","ref":"Webhoox.html#module-installation"},{"type":"behaviour","title":"Webhoox.Adapter","doc":"Behaviour for handling webhooks","ref":"Webhoox.Adapter.html"},{"type":"callback","title":"Webhoox.Adapter.handle_webhook/3","doc":"","ref":"Webhoox.Adapter.html#c:handle_webhook/3"},{"type":"module","title":"Webhoox.Adapter.Hasura","doc":"Webhoox Adapter for Hasura Events and Actions","ref":"Webhoox.Adapter.Hasura.html"},{"type":"function","title":"Webhoox.Adapter.Hasura.handle_webhook/3","doc":"","ref":"Webhoox.Adapter.Hasura.html#handle_webhook/3"},{"type":"function","title":"Webhoox.Adapter.Hasura.normalize_params/1","doc":"Handles a Hasura webhook:\n  - Action: https://hasura.io/docs/latest/graphql/core/actions/action-handlers/#http-handler\n  - Event: https://hasura.io/docs/latest/graphql/core/event-triggers/payload.html#json-payload","ref":"Webhoox.Adapter.Hasura.html#normalize_params/1"},{"type":"module","title":"Webhoox.Adapter.Mailersend","doc":"Mailersend Adapter\nNote: Must set up custom parser to set raw_body:\n- https://stackoverflow.com/questions/41510957/read-the-raw-body-from-a-plug-connection-after-parsers-in-elixir\n- https://hexdocs.pm/plug/Plug.Parsers.html#module-custom-body-reader","ref":"Webhoox.Adapter.Mailersend.html"},{"type":"function","title":"Webhoox.Adapter.Mailersend.handle_webhook/3","doc":"","ref":"Webhoox.Adapter.Mailersend.html#handle_webhook/3"},{"type":"function","title":"Webhoox.Adapter.Mailersend.normalize_params/1","doc":"Handle Mailersend v1 webhook type","ref":"Webhoox.Adapter.Mailersend.html#normalize_params/1"},{"type":"module","title":"Webhoox.Adapter.Parsio","doc":"Parsio.io Adapter\n- https://help.parsio.io/data-export-integrations/send-data-to-webhook-1#secure-your-webhooks-optional","ref":"Webhoox.Adapter.Parsio.html"},{"type":"function","title":"Webhoox.Adapter.Parsio.handle_webhook/3","doc":"","ref":"Webhoox.Adapter.Parsio.html#handle_webhook/3"},{"type":"function","title":"Webhoox.Adapter.Parsio.normalize_params/1","doc":"","ref":"Webhoox.Adapter.Parsio.html#normalize_params/1"},{"type":"module","title":"Webhoox.Adapter.S3","doc":"Webhoox Adapter for s3 compatible Events","ref":"Webhoox.Adapter.S3.html"},{"type":"function","title":"Webhoox.Adapter.S3.handle_webhook/3","doc":"","ref":"Webhoox.Adapter.S3.html#handle_webhook/3"},{"type":"function","title":"Webhoox.Adapter.S3.normalize_params/1","doc":"Handles an s3 compatible webhook:\n  - https://docs.aws.amazon.com/AmazonS3/latest/userguide/notification-how-to-event-types-and-destinations.html\n  - https://docs.aws.amazon.com/AmazonS3/latest/userguide/notification-content-structure.html\n  - https://docs.min.io/docs/minio-bucket-notification-guide.html","ref":"Webhoox.Adapter.S3.html#normalize_params/1"},{"type":"module","title":"Webhoox.Adapter.StandardWebhook","doc":"Standard Webhook Adapter\nRead more here: https://standardwebhooks.com","ref":"Webhoox.Adapter.StandardWebhook.html"},{"type":"function","title":"Webhoox.Adapter.StandardWebhook.handle_webhook/3","doc":"","ref":"Webhoox.Adapter.StandardWebhook.html#handle_webhook/3"},{"type":"function","title":"Webhoox.Adapter.StandardWebhook.normalize_params/2","doc":"","ref":"Webhoox.Adapter.StandardWebhook.html#normalize_params/2"},{"type":"module","title":"Webhoox.Authentication.StandardWebhook","doc":"Standard Webhook Authentication (verify and sign)\nRead more here: https://standardwebhooks.com","ref":"Webhoox.Authentication.StandardWebhook.html"},{"type":"function","title":"Webhoox.Authentication.StandardWebhook.sign/4","doc":"Sign a Standard Webhook given an id, timestamp, payload and secret","ref":"Webhoox.Authentication.StandardWebhook.html#sign/4"},{"type":"function","title":"Webhoox.Authentication.StandardWebhook.validate_timestamp/1","doc":"","ref":"Webhoox.Authentication.StandardWebhook.html#validate_timestamp/1"},{"type":"function","title":"Webhoox.Authentication.StandardWebhook.verify/3","doc":"Verify a Standard Webhook given a Plug.Conn, payload and secret","ref":"Webhoox.Authentication.StandardWebhook.html#verify/3"},{"type":"behaviour","title":"Webhoox.Handler","doc":"Behaviour for handling incoming webhook","ref":"Webhoox.Handler.html"},{"type":"callback","title":"Webhoox.Handler.process/1","doc":"","ref":"Webhoox.Handler.html#c:process/1"},{"type":"module","title":"Webhoox.Utility.Response","doc":"","ref":"Webhoox.Utility.Response.html"},{"type":"function","title":"Webhoox.Utility.Response.bad_request/1","doc":"","ref":"Webhoox.Utility.Response.html#bad_request/1"},{"type":"function","title":"Webhoox.Utility.Response.unauthorized_request/1","doc":"","ref":"Webhoox.Utility.Response.html#unauthorized_request/1"},{"type":"module","title":"Webhoox.Webhook.Email","doc":"Struct modeling incoming email","ref":"Webhoox.Webhook.Email.html"},{"type":"type","title":"Webhoox.Webhook.Email.address/0","doc":"","ref":"Webhoox.Webhook.Email.html#t:address/0"},{"type":"type","title":"Webhoox.Webhook.Email.t/0","doc":"","ref":"Webhoox.Webhook.Email.html#t:t/0"},{"type":"module","title":"Webhoox.Webhook.Hasura.Action","doc":"Struct modeling incoming Hasura Action","ref":"Webhoox.Webhook.Hasura.Action.html"},{"type":"type","title":"Webhoox.Webhook.Hasura.Action.t/0","doc":"","ref":"Webhoox.Webhook.Hasura.Action.html#t:t/0"},{"type":"module","title":"Webhoox.Webhook.Hasura.Event","doc":"Struct modeling incoming Hasura Event","ref":"Webhoox.Webhook.Hasura.Event.html"},{"type":"type","title":"Webhoox.Webhook.Hasura.Event.t/0","doc":"","ref":"Webhoox.Webhook.Hasura.Event.html#t:t/0"},{"type":"module","title":"Webhoox.Webhook.Parsio","doc":"Struct modeling incoming Parsio parsed email","ref":"Webhoox.Webhook.Parsio.html"},{"type":"type","title":"Webhoox.Webhook.Parsio.t/0","doc":"","ref":"Webhoox.Webhook.Parsio.html#t:t/0"},{"type":"module","title":"Webhoox.Webhook.S3","doc":"Struct modeling incoming s3 compatible Events","ref":"Webhoox.Webhook.S3.html"},{"type":"type","title":"Webhoox.Webhook.S3.t/0","doc":"","ref":"Webhoox.Webhook.S3.html#t:t/0"},{"type":"module","title":"Webhoox.Webhook.StandardWebhook","doc":"Struct modeling incoming Standard Webhooks compatible Events\nRead more here: https://standardwebhooks.com","ref":"Webhoox.Webhook.StandardWebhook.html"},{"type":"type","title":"Webhoox.Webhook.StandardWebhook.t/0","doc":"","ref":"Webhoox.Webhook.StandardWebhook.html#t:t/0"},{"type":"extras","title":"Webhoox","doc":"# Webhoox\n\nWebhoox makes it easy to deal with inbound webhooks by using an adapter-based approach, saving you time.\n\nThis library started off as a fork of Maarten's awesome [receivex](https://github.com/maartenvanvliet/receivex) email-focused library.\n\nWebhoox aims to support the [Standard Webhooks](https://www.standardwebhooks.com/) spec and includes an [authentication module](./lib/webhoox/authentication/standard_webhook.ex) and [adapter](./lib/webhoox/adapters/standard_webhook.ex)","ref":"readme.html"},{"type":"extras","title":"Adapters - Webhoox","doc":"- [Standard Webhook](./lib/webhoox/adapters/standard_webhook.ex)\n- [MailerSend](./lib/webhoox/adapters/mailersend.ex)\n- [Mailgun](./lib/webhoox/adapters/mailgun.ex)\n- [Mandrill](./lib/webhoox/adapters/mandrill.ex)\n- [Hasura](./lib/webhoox/adapters/hasura.ex)\n- [s3](./lib/webhoox/adapters/s3.ex)\n- [Parsio](./lib/webhoox/adapters/parsio.ex)\n\nYou can implement your own adapter by following the existing adapters as an example. Pull requests for new adapters welcome!","ref":"readme.html#adapters"},{"type":"extras","title":"Installation - Webhoox","doc":"[Available in Hex](https://hex.pm/packages/webhoox), the package can be installed\nby adding `webhoox` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:webhoox, \"~> 0.3.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Webhoox","doc":"Example configuration for Standard Webhook with the Plug router:\n\n```elixir\n# Your router.ex file\nforward(\"_incoming\", to: Webhoox, init_opts: [\n  adapter: Webhoox.Adapter.StandardWebhook,\n  adapter_opts: [secret: \"MfKQ9r8GKYqrTwjUPD8ILPZIo2LaLaSw\"],\n  handler: Example.Processor]\n)\n```\n\nExample Processor:\n\n```elixir\n  defmodule Example.Processor do\n    @behaviour Webhoox.Handler\n\n    def process(webhook = %Webhoox.Webhook.StandardWebhook{}) do\n      # You probably want to handle processing of the event asynchronously\n      # and go ahead and return a 200 as not to block the sending server\n      \n      {:ok, \"200 OK\"}\n    end\n  end\n```\n\nDocumentation can be found at [https://hex.pm/packages/webhoox](https://hex.pm/packages/webhoox).","ref":"readme.html#configuration"}],"content_type":"text/markdown"}